/**
 * Created by yaowenh on 14-4-25.
 */

require(["jquery", "converse"], function ($, converse) {

    var config = Jabze.config;
    var notiBox = $('#jabze-noti-box');

    $('#not-show-jabze-noti').click(function () {
        window.localStorage.notShowJabezeNoti = 1;
        notiBox.fadeOut();
    });
    $("#why-disabled").click(function () {
        $(this).parent().hide();
        $("#info-disabled").show();
    });
    $(".close-chat").click(function () {
        notiBox.hide();
    });

    if (window.localStorage.notShowJabezeNoti == 0) {
        notiBox.delay(60 * 1000).fadeIn('slow');
    }

    var jabze_isConnecting = 0;

    //require.config(config.requireConfig);

    // Set up converse.js
    converse.initialize({
        auto_list_rooms: false,
        auto_subscribe: true,
        bosh_service_url: (window.WebSocket && $.browser.safari) ? config.endpoint.websocket : config.endpoint.bosh,
        hide_muc_server: true,
        i18n: locales.en, // Refer to ./locale/locales.js to see which locales are supported
        prebind: true,
        xhr_user_search: false,
        animate: true
    });


    var __ = function (str) {
        var t = converse.i18n.translate(str);
        if (arguments.length > 1) {
            return t.fetch.apply(t, [].slice.call(arguments, 1));
        } else {
            return t.fetch();
        }
    };

    var lazyLogin = setInterval(function () {
        $('div#toggle-controlbox').click();
    }, 90 * 1000);

    $('.toggle-online-users').bind(
        'click',
        $.proxy(function (e) {
            e.preventDefault();
            if (converse.connection && converse.connection.connected === true) {
                converse.toggleControlBox();
            }
        }, this)
    );
    $('#jabze-show-help').click(function (e) {
        notiBox.toggle();
        //todo  resync current user
        // clearTimeout(notiBoxInt);
        return false;
    });
    $('div#toggle-controlbox').click(function () {
        if(!config.enableConnect){
            notiBox.show();
            return;
        }
        notiBox.fadeOut();
        /*
         if(current_user_domain!=jabze_domain){

         return;
         }*/
        if ($.browser.msie && 9 > $.browser.version) {
            alert('The Jabze Chat plugin only supports Internet Explorer version 9 or above, your version of IE ' + $.browser.version + ' is not supported.');
            return false;
        }
        if (0 === jabze_isConnecting) {
            clearTimeout(lazyLogin);
            if (!converse.connection) {
                jabze_isConnecting = 1;
                connected();
            } else {
                if (converse.connection.connected === false) {
                    jabze_isConnecting = 1;
                    connected();
                }
            }
        }

    });

    function connected() {
        var connection = new Strophe.Connection(converse.bosh_service_url);
        connection.connect(config.jid, config.password, function (status, message) {
            if (status === Strophe.Status.CONNECTED) {
                console.log(__('Connected'));

                converse.showControlBox();
                converse.onConnected(connection);

                connection.vcard = {
                    'get': function (callback, jid) {
                    }
                };
                $('#toggle-controlbox').addClass('controlbox-online');
            } else if (status === Strophe.Status.DISCONNECTED) {
                converse.giveFeedback(__('Disconnected'), 'error');
            } else if (status === Strophe.Status.Error) {
                converse.giveFeedback(__('Error'), 'error');
            } else if (status === Strophe.Status.CONNECTING) {
                converse.giveFeedback(__('Connecting'));
                return true;
            } else if (status === Strophe.Status.CONNFAIL) {
                converse.giveFeedback(__('Connection Failed'), 'error');
            } else if (status === Strophe.Status.AUTHENTICATING) {
                converse.giveFeedback(__('Authenticating'));
                return true;
            } else if (status === Strophe.Status.AUTHFAIL) {
                converse.giveFeedback(__('Authentication Failed'), 'error');
            } else if (status === Strophe.Status.DISCONNECTING) {
                converse.giveFeedback(__('Disconnecting'), 'error');
            } else if (status === Strophe.Status.ATTACHED) {
                console.log(__('Attached'));
            }
            jabze_isConnecting = 0;
        });
    }
});
