<?php
/*
Plugin Name: Jabze Chat
Plugin URI: http://www.jabze.com/site/page/web-based-chat-for-wordpress
Description: Jabze is an industrial strength and IT friendly messenger service, with a great mobile experience. Jabze Chat is
the WordPress extension to enable chat function on a WordPress site for signed-in users. It is most useful in an intranet
environment. 
Author: jabze
Version: 1.5.2
Author URI: http://www.jabze.com
License: GPLv2 or later
*/

/* Copyright 2013 Sumilux Technologies, Inc. (email: info@sumilux.com)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/


define('JABZE_VERSION', '1.5.2');
define('JABZE_PLUGIN_URL', plugin_dir_url(__FILE__));
define('JABZE_APP_NAME', 'Jabze Chat');
//todo change to https url
define('JABZE_CHAT_URL', 'https://wpsvc.jabze.com/http-bind/');
//define('JABZE_CHAT_URL', 'https://hf113.sumilux.com/http-bind/');

// if is safari use web socket
define('JABZE_CHAT_URL_WEB_SOCKET','ws://www.jabze.com:5290');
//define('JABZE_CHAT_URL_WEB_SOCKET','ws://hf113.sumilux.com:5290');

//TODO use ssl
define('JABZE_RESTFUl_URL', 'https://wpsvc.jabze.com/');
//define('JABZE_RESTFUl_URL', 'https://hf113.sumilux.com/');
define('JABZE_SETUP_URL', JABZE_RESTFUl_URL . 'api/wordpressSetUp/version/'.JABZE_VERSION);
define('JABZE_SYNC_URL', JABZE_RESTFUl_URL . 'api/wordPressSync/version/'.JABZE_VERSION.'/type/sync');
define('JABZE_SEND_CODE_URL', JABZE_RESTFUl_URL . 'api/wordpressSendCode/version/'.JABZE_VERSION);
define('JABZE_CHECK_STATUS_URL', JABZE_RESTFUl_URL . 'api/wordpressCheckStatus/version/'.JABZE_VERSION);
define('JABZE_CHECK_VERSION_URL', JABZE_RESTFUl_URL . 'api/wordpressCheckVersion/version/'.JABZE_VERSION);
define('JABZE_CHECK_iS_USER_ACTIVE_URL', JABZE_RESTFUl_URL . 'api/isUserActive/version/'.JABZE_VERSION);
define('JABZE_SEND_LOG_URL', JABZE_RESTFUl_URL . 'api/log');
define('JABZE_ORG_CODE_URL',JABZE_RESTFUl_URL. 'api/getOrgCode');

$jabze_domain_name = 'jabze_domain';
$jabze_org_code_name = 'jabze_org_code';
$jabze_access_token_name = 'jabze_access_token';
$jabze_email_name='jabze_email';
$jabze_auth_secret_name='jabze_auth_secret';
$jabze_setup_error_code_name = 'jabze_setup_error_code';
$jabze_setup_error_msg_name = 'jabze_setup_error_msg';
$jabze_enable_registration_suggestion_name = 'jabze_enable_registration_suggestion';

$jabze_domain = get_option($jabze_domain_name);
$jabze_access_token = get_option($jabze_access_token_name);
$jabze_auth_secret= get_option($jabze_auth_secret_name);
$jabze_org_code  = get_option($jabze_org_code_name);

$jabze_enable_registration_suggestion=get_option($jabze_enable_registration_suggestion_name);
$jabze_need_upgrade=0;
$jabze_need_upgrade_msg='';
$jabze_server_status=1;
$jabze_server_status_msg = "";
// Make sure we don't expose any info if called directly
if (!function_exists('add_action')) {
    echo 'Hi there!  I\'m just a plugin, not much I can do when called directly.';
    exit;
}

if(empty($jabze_org_code) && !empty($jabze_domain)){
    $json = call(JABZE_ORG_CODE_URL,  array('domainName' => $jabze_domain));

    if ($json->success) {
        $jabze_org_code = $json->orgCode;
        if (!add_option($jabze_org_code_name, $jabze_org_code))
            update_option($jabze_org_code_name, $jabze_org_code);
    }
}

function getJabzeLoginUrl(){
    global $jabze_org_code;
    $jabze_url = JABZE_RESTFUl_URL."org/wordpressLogin";
    if(strpos($jabze_url,'wpsvc')){
        $prod= true;
    }else{
        $prod= false;
    }
    if(empty($jabze_org_code)){
        if($prod){
            $jabze_url =  str_replace("wpsvc.","",$jabze_url);
        }
    }else{

        if($prod){
            $jabze_url = str_replace("wpsvc",$jabze_org_code,$jabze_url);
        }else{
            //for test
            $jabze_url = str_replace("hf26",$jabze_org_code.".hf26",$jabze_url);
            $jabze_url = str_replace("hf113",$jabze_org_code.".hf113",$jabze_url);
        }

    }
    return $jabze_url;
}
/**
 * Add column to database table, if column doesn't already exist in table.
 *
 * @since 1.0.0
 * @package WordPress
 * @subpackage Plugin
 * @uses $wpdb
 *
 * @param string $table_name Database table name
 * @param string $column_name Table column name
 * @param string $create_ddl SQL to add column to table.
 * @return bool False on failure. True, if already exists or was successful.
 */
function jabze_add_column($table_name, $column_name, $create_ddl)
{
    global $wpdb;
    foreach ($wpdb->get_col("DESC $table_name", 0) as $column) {

        if ($column == $column_name) {
            return true;
        }
    }
    //didn't find it try to create it.
    $wpdb->query($create_ddl);
    // we cannot directly tell that whether this succeeded!
    foreach ($wpdb->get_col("DESC $table_name", 0) as $column) {
        if ($column == $column_name) {
            return true;
        }
    }
    return false;
}

/**
 *
 * Drop column to database table, if column doesn't already exist in table.
 *
 * @since 1.0.0
 * @package WordPress
 * @subpackage Plugin
 * @uses $wpdb
 *
 * @param string $table_name Database table name
 * @param string $column_name Table column name
 * @param string $drop_ddl SQL to add column to table.
 * @return bool False on failure. True, if already exists or was successful.
 */
function jabze_drop_column($table_name, $column_name, $drop_ddl)
{
    global $wpdb;
    foreach ($wpdb->get_col("DESC $table_name", 0) as $column) {
        if ($column == $column_name) {
            //found it try to drop it.
            $wpdb->query($drop_ddl);
            // we cannot directly tell that whether this succeeded!
            foreach ($wpdb->get_col("DESC $table_name", 0) as $column) {
                if ($column == $column_name) {
                    return false;
                }
            }
        }
    }
    // else didn't find it
    return true;
}

function remove_jabze_sync()
{
    global $wpdb;
    if (!jabze_drop_column($wpdb->users, 'jabze_sync_status', 'ALTER TABLE `' . $wpdb->users . '` DROP COLUMN `jabze_sync_status`')) {
        add_option('jabze_setup_error_code', '500');
        add_option('jabze_setup_error_msg', 'Drop jabze_sync_status in ' . $wpdb->users . ' encountered an error .');
        add_action('admin_notices', 'jabze_alert');
        jabze_log('Drop jabze_sync_status in ' . $wpdb->users . ' encountered an error .');
        return false;
    }

}
/**
 * remove jabze option
 */
function remove_jabze_option()
{
    //global $jabze_domain_name,$jabze_access_token_name,$jabze_email_name,$jabze_auth_secret_name;

    $jabze_domain_name = 'jabze_domain';
    $jabze_access_token_name = 'jabze_access_token';
    $jabze_email_name='jabze_email';
    $jabze_auth_secret_name='jabze_auth_secret';
    $jabze_org_code_name = 'jabze_org_code';

    if(get_option($jabze_org_code_name)){
        delete_option($jabze_org_code_name);
    }
    if(get_option($jabze_domain_name)){
        delete_option($jabze_domain_name);
    }
    if(get_option($jabze_access_token_name)){
        delete_option($jabze_access_token_name);
    }

    if(get_option($jabze_email_name)){
        delete_option($jabze_email_name);
    }

    if(get_option($jabze_auth_secret_name)){
        delete_option($jabze_auth_secret_name);
    }

}
/**
 * reset all jabze sync status
 */
function reset_jabze_sync()
{
    global $wpdb;
    $wpdb->query("UPDATE `" . $wpdb->users . "` set jabze_sync_status=0");
}

/**
 *
 * jabze unistall
 * @return bool
 *
 */
function jabze_uninstall()
{

    remove_jabze_sync();

    remove_jabze_option();
}

register_uninstall_hook(__FILE__, 'jabze_uninstall');


/**
 *
 * jabze activate
 * @return bool
 *
 */
function jabze_activate()
{
    global $wpdb;
    $add_sync_status = jabze_add_column($wpdb->users, 'jabze_sync_status', 'ALTER TABLE `' . $wpdb->users . '` ADD COLUMN `jabze_sync_status`  TINYINT(1) DEFAULT 0;');
    $add_active_status = jabze_add_column($wpdb->users, 'jabze_active_status', 'ALTER TABLE `' . $wpdb->users . '` ADD COLUMN `jabze_active_status`  TINYINT(1) DEFAULT 0;');
    if (!$add_sync_status || !$add_active_status) {
        add_option('jabze_setup_error_code', '500');
        add_option('jabze_setup_error_msg', 'Add jabze_sync_status in ' . $wpdb->users . ' had some error .');
        add_action('admin_notices', 'jabze_alert');
        jabze_log('Add jabze_sync_status and jabze_active_status in ' . $wpdb->users . ' had some error .');
        return false;
    }
}

register_activation_hook(__FILE__, 'jabze_activate');

function jabze_check_version(){
    global $jabze_need_upgrade_msg,$jabze_need_upgrade,$jabze_server_status,$jabze_server_status_msg;
    $json = call(JABZE_CHECK_VERSION_URL, array());

    if($json->success){
        $jabze_need_upgrade=0;
    }else{
        if(isset($json->error) && $json->error=='curl'){
            $jabze_server_status=0;
            $jabze_server_status_msg = $json->msg;
        }else{
            $jabze_need_upgrade=1;
            $jabze_need_upgrade_msg=$json->msg;
        }

    }
}

function jabze_enable_suggestion($flag){
    global $jabze_enable_registration_suggestion_name,$jabze_enable_registration_suggestion;


    if (!add_option($jabze_enable_registration_suggestion_name, $flag))
        update_option($jabze_enable_registration_suggestion_name, $flag);

    $jabze_enable_registration_suggestion=$flag;
}

function jabze_sendCode()
{
    global $jabze_email_name,$jabze_domain;

    if(isset($_POST['getback'])){
        $email=$_POST['uname']."@".$jabze_domain;
    }else{
        $email =$_POST['email'];
    }
    $current_user = wp_get_current_user();
    $current_user_email = $current_user->user_email;
    List(,$user_domain) = explode("@",$current_user_email);
    List(,$code_domain) = explode("@",$email);
    if($user_domain!==$code_domain){
        return array(
            "success" => false,
            "msg" => "your email address does not match the domain"
        );
    }

    if (!add_option($jabze_email_name, $email))
        update_option($jabze_email_name, $email);

    $json = call(JABZE_SEND_CODE_URL, array(), array('email' => $email));

    if ($json->success) {
        $msg = "Thank you for requesting an email address verification, we have just sent you the verification code. ";
        $json->msg=$msg;
    }
    return $json;
}
function jabze_log($message){
    call(JABZE_SEND_LOG_URL, array('name'=>'WP plugin', 'location'=>get_option('siteurl'), 'version'=>JABZE_VERSION,'message'=>$message));
}

function jabze_setup()
{

    global $jabze_domain, $jabze_access_token,$jabze_auth_secret,$jabze_email_name,$jabze_domain_name,$jabze_access_token_name,$jabze_auth_secret_name,$jabze_org_code_name;

    $jabze_email= get_option($jabze_email_name);
    $site_name = get_option('blogname');
    $site_url = get_option('siteurl');
    $admin_email = get_option('admin_email');

    $current_user = wp_get_current_user();
    $intro = array('siteName' => $site_name, 'siteUrl' => $site_url, 'adminEmail' => $admin_email,'admin'=>array('uname'=>$current_user->user_login,'email'=>$current_user->user_email,'name'=>$current_user->display_name));

    if( preg_match('/[^-\w_\.]/',$intro['admin']['uname']) !== 0){
        return array(
            "success"=>false,
            'error'=>'invalid',
            'msg'=> 'User Name:'.$current_user->user_login.' is not valid. only alpha-numerical and DOT characters are allowed'
        );

    }
    $code=$_POST['code'];

    //$json =  json_decode('{"domain":"qq.com","accessToken":"unETaqUrybUJyTYtENUJu7ABUPE8a2yp","authSecret":"099f234bf20b3801fccd2903","success":true}');
    $json = call(JABZE_SETUP_URL, array(), array('email'=>$jabze_email,'code'=>$code,'intro' => $intro));

    if ($json->success) {
        $jabze_domain = $json->domain;
        $jabze_access_token = $json->accessToken;
        $jabze_auth_secret=$json->authSecret;
        $jabze_org_code = $json->orgCode;
        //reset sync when set up
        reset_jabze_sync();
        //upate admin sync status
        update_user_sync_status($current_user->ID, 1);

        if (!add_option($jabze_domain_name, $jabze_domain))
            update_option($jabze_domain_name, $jabze_domain);

        if (!add_option($jabze_access_token_name, $jabze_access_token))
            update_option($jabze_access_token_name, $jabze_access_token);

        if (!add_option($jabze_auth_secret_name,$jabze_auth_secret))
            update_option($jabze_auth_secret_name, $jabze_auth_secret);

        if (!add_option($jabze_org_code_name,$jabze_org_code))
            update_option($jabze_org_code_name, $jabze_org_code);
    }

    return $json;

}
function jabze_getSyncUsers(){
    $argc=array(
        //'search' => '*'.$domain,
        //'search_columns' =>array('user_email'),
        'orderby' => 'ID',
        'order' => 'ASC',
    );
    return get_users($argc);
}
function jabze_sync($userIDs,$type="sync")
{
    global $jabze_domain, $jabze_access_token;

    $sync_url = JABZE_SYNC_URL .'/domain/' . $jabze_domain . '/accessToken/' . $jabze_access_token;

    $syncUser=array();
    //$role_groups=jabze_getRoleGroups();
    $argc=array(
        'include'=> $userIDs,
        'orderby' => 'ID',
        'order' => 'ASC',
    );

    $blogusers = get_users($argc);

    if($blogusers){
        foreach($blogusers as $user){

            if($user->jabze_sync_status!=3){
                $syncUser[]=array(
                    'id'=>$user->ID,
                    'name'=>$user->display_name,
                    'email'=>$user->user_email,
                    'uname'=>$user->user_login,
                    // 'uname'=>$uname,
                    'role'=>$user->roles[0]
                );
            }
        }
    }


    $json = call($sync_url, array(), array('users' => json_encode($syncUser)));

    if ($json->success) {
        foreach ($json->users as $user) {
            if ($user->state == true) {
                update_user_sync_status($user->id, 3);
            } else {
                update_user_sync_status($user->id, 2);
            }
        }
    }else{
        jabze_log($json->msg);
    }
    return $json;

}

/**
 *
 * let role level role had less than role
 * format user roles like this
 * array('adminstrator'=>array(0=>'administartor',1=>'editor',...)
 * @return array
 */
function jabze_getRoleGroups(){
    global $wp_roles;
    $role_groups=$tmp_groups=array();
    foreach ($wp_roles->roles as $role_name => $role) {
        $level = 0;
        for ($i = 0; $i <= 10; $i++)
            if (!empty($role['capabilities']["level_$i"]))
                $level = $i;
        $role_levels[$role_name] = $level;
        $tmp_groups[]=$role_name;
    }
    foreach($tmp_groups as $role_name){
        $level = $role_levels[$role_name];
        $role_groups[$role_name][]=$role_name;
        foreach($role_levels as $name=> $p){
            if($level>$p){
                $role_groups[$role_name][]=$name;
            }
        }

    }
    return $role_groups;
}

function update_user_sync_status($id, $value)
{
    global $wpdb;
    $wpdb->update($wpdb->users, array('jabze_sync_status' => $value), array('ID' => $id));
}
function update_user_jabze_status($id, $value){
    global $wpdb;
    $wpdb->update($wpdb->users, array('jabze_active_status' => $value), array('ID' => $id));
}
function add_column_active_status(){
    global $wpdb;
    $add_active_status = jabze_add_column($wpdb->users, 'jabze_active_status', 'ALTER TABLE `' . $wpdb->users . '` ADD COLUMN `jabze_active_status`  TINYINT(1) DEFAULT 0;');
    if ( !$add_active_status) {
        add_option('jabze_setup_error_code', '500');
        add_option('jabze_setup_error_msg', 'Add jabze_sync_status in ' . $wpdb->users . ' had some error .');
        add_action('admin_notices', 'jabze_alert');
        jabze_log('Add  jabze_active_status in ' . $wpdb->users . ' had some error .');
        return false;
    }
}
//check current user active status in wordpress
function is_current_user_active_in_jabze(){
    $current_user = wp_get_current_user();
    if(!isset($current_user->jabze_active_status)){
        add_column_active_status();
    }
    $active_in_jabze = $current_user->jabze_active_status;
    if(!$active_in_jabze){//not active in jabze server
        return false;
    }else{
        return true;
    }
}
//get user active status from jabze server ,and update in wordpress
function get_current_user_status_in_jabze(){
    global $jabze_domain, $jabze_access_token;
    $current_user = wp_get_current_user();
    $email = strtolower($current_user->user_login). '@'.$jabze_domain;
    $isUserActiveUrl = JABZE_CHECK_iS_USER_ACTIVE_URL .'/email/'.$email.'/domainName/' . $jabze_domain . '/accessToken/' . $jabze_access_token;
    $json = call($isUserActiveUrl, array());

    if($json->success){
        $isUserActive =  $json->isActive;
    }else{
        $isUserActive = false;
    }
    if($isUserActive){
        update_user_jabze_status($current_user->id,1);
    }
    return $isUserActive;

}
function jabze_check_key_status()
{
    global  $jabze_access_token,$jabze_auth_secret,$jabze_domain,$jabze_auth_secret_name;

    //$domain=$_POST['domain'];
    //$accessToken=$_POST['accessToken'];

    //TODO need check status api
    $json = call(JABZE_CHECK_STATUS_URL, array(), array('accessToken'=>$jabze_access_token,'domain'=>$jabze_domain));

    if ($json->success) {

        $jabze_auth_secret=$json->authSecret;

        /*if (!add_option($jabze_domain_name, $jabze_domain_name))
            update_option($jabze_domain_name, $jabze_domain_name);

        if (!add_option($jabze_access_token_name, $jabze_access_token))
            update_option($jabze_access_token_name, $jabze_access_token);*/

        if (!add_option($jabze_auth_secret_name,$jabze_auth_secret))
            update_option($jabze_auth_secret_name, $jabze_auth_secret);

        //reset_jabze_sync();
        //jabze_sync();
    }else{
        $json->msg="Your domain name does not match the activation key. Please retrieve the activation key, and reconfigure the Jabze Chat plugin for domain: ".$jabze_domain;
    }

    return $json;

}

/**
 * call reset-ful url add get json object
 * @param $url
 * @param $params
 * @param array $posts
 * @return array|mixed
 */
function call($url, $params, $posts = array())
{
    //$url=$url.'/version/'.JABZE_VERSION;
    $query = http_build_query($params);

    if ($query)
        $url = $url . '&' . $query;

    $data = getResponse($url, $posts);

    return json_decode(trim($data));
}

/**
 * @param string $url
 * @param array $posts defalut empty array, then it will use GET method to obtain data
 * @return mixed
 */
function getResponse($url, $posts = array())
{
    if(!function_exists('curl_init')) {
        return '{"success":false,"error":"curl","msg":"curl extension is unavailable."}';
    }
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
    curl_setopt($ch, CURLOPT_HEADER, 0);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 5);
    curl_setopt($ch, CURLOPT_TIMEOUT, 60);

    if (!empty($posts)) {
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($posts));
    }

    $data = curl_exec($ch);

    if (curl_errno($ch)) {
        curl_close($ch);
        return '{"success":false,"error":"curl","msg":"Unable to connect to the Jabze server"}';
    }

    $httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
    if($httpCode!= 200){
        return '{"success":false,"error":"curl","msg":"Unable to connect to the Jabze server"}';
    }

    curl_close($ch);
    return $data;
}
function is_current_user_need_sync(){
    $current_user = wp_get_current_user();

    $jabzeSync = $current_user->jabze_sync_status;//to do.check

    //only alpha-numerical and DOT characters are allowed in uid
    if( preg_match('/[^-\w_\.]/',$current_user->user_login) !== 0){
        return false;
    }
    if($jabzeSync==1||$jabzeSync==3){//has sync, for plugin updae check user email_name match uname?
        return false;
    }else{
        return true;
    }
}

function theme_styles()
{
    wp_register_style('converse', JABZE_PLUGIN_URL . 'assets/css/converse.css', array(), '1.0.0');
    wp_enqueue_style('converse');
}

add_action('wp_enqueue_scripts', 'theme_styles');

function jabze_widget() {

    global $jabze_domain,$jabze_auth_secret,$jabze_access_token,$jabze_enable_registration_suggestion;
    $current_user = wp_get_current_user();
    List(,$current_user_domain) = explode("@",$current_user->user_email);
    //if not init ,not show this widget
    if(!$jabze_auth_secret || !$jabze_domain){
        return ;
    }


if (0 != $current_user->ID):
    $jabzeSync = is_current_user_need_sync();


    $otherLoginUrl=getJabzeLoginUrl();
    $user_login_name = strtolower($current_user->user_login);

    $name_valid = preg_match('/[^-\w_\.]/',$user_login_name)  == 0 ? true :false;

    $jid= $user_login_name. '@'.$jabze_domain;
    $me = $user_login_name. '@'.$jabze_domain.'/jabze_wp_plugin';
    $pass = sha1($jabze_auth_secret.$jid);
    $timestamp=time();
    $signature= md5($jabze_domain . $user_login_name . $timestamp . $jabze_access_token);
?>
        <div id="chatpanel" xmlns="http://www.w3.org/1999/html">
            <div class="box" id="jabze-noti-box">
                <div class="arrow"></div>
                <div class="arrow-border"></div>
                <ul>
                    <li><strong>Jabze Chat!</strong> <a class="close-chat">x</a></li>
                </ul>
                <?php
                    if($name_valid):
                ?>
                    <p>
                        Jabze Chat on this site offers Instant Messaging
                        for every logged-in user.
                        Click on the chat status bar at the VERY BOTTOM of this page, see who's online and chat away!
                    </p>
                    <p>
                        Additional features are also available from our desktop and mobile apps, click below to set up:  <br>
                    <form action="<?php echo $otherLoginUrl;?>" method="post" target="_blank" id="wordpressLogin">
                        <input type="hidden" name="domainName" value="<?php echo $jabze_domain;?>"/>
                        <input type="hidden" name="userName" value="<?php echo $user_login_name;?>"/>

                        <input type="hidden" name="timestamp" value="<?php echo $timestamp;?>"/>
                        <input type="hidden" name="signature" value="<?php echo $signature;?>"/>
                        <input type="hidden" id="loginType" name="loginType" value="<?php echo $signature;?>"/>
                        <div style="display: inline-block;">
                            <button type="submit" class="button button-primary" onclick="jQuery('#loginType').val('webapp')">Web App</button>
                            <button  class="button button-primary" style="margin-left: 10px;" onclick="jQuery('#loginType').val('iphone')">iPhone App</button>
                            <button  class="button button-primary" style="margin-left: 10px;" onclick="jQuery('#loginType').val('android')">Android App</button>
                        </div>
                    </form>
                    </p>
                   <a id="not-show-jabze-noti"  style="font-size: 12px;padding: 3px;">Got it, don't show this message again.</a>
                <?php else:?>
                        <p>
                            Sorry, can't proceed for your account name[<?php echo $user_login_name;?>] contains illegal character.
                            Illegal Characters: Blank space,@,%,*,& etc.
                        </p>
                <?php endif;?>

            </div>
            <div id="collective-xmpp-chat-data"></div>
            <div id="toggle-controlbox" class="open">
                <a href="#" class="chat toggle-online-users">
                    <strong class="conn-feedback">Jabze Chat</strong>
                    <strong style="display: none" id="online-count">(0)</strong>
                    <strong id="jabze-show-help" style="color: green;float: left;margin-left:6px;">?</strong>
                </a>
            </div>
        </div>
        <?php

        if ($jabzeSync):
            $ids[]=$current_user->ID;
            if (!jabze_sync($ids)):
                return;
            endif;
        endif;
?>
    <script type="text/javascript">
        window.Jabze = {
            config:<?php echo json_encode(array(
                    'jid' => $me,
                    'password' => $pass,
                    'requireConfig' => array('baseUrl' => JABZE_PLUGIN_URL. 'assets/js'),
                    'endpoint' => array(
                        'bosh' => JABZE_CHAT_URL,
                        'websocket' => JABZE_CHAT_URL_WEB_SOCKET,
                    ),
                    'enableConnect'=> $name_valid ? true : false
                ));?>
        };

    </script>
    <script data-main="<?php echo JABZE_PLUGIN_URL;?>assets/js/jabze.js" src="<?php echo JABZE_PLUGIN_URL;?>assets/js/Libraries/require-jquery.js"></script>

    <?php
    elseif("0" !== $jabze_enable_registration_suggestion):
        ?>
        <div id="chatpanel" xmlns="http://www.w3.org/1999/html">
            <div class="box" id="jabze-noti-box">
                <div class="arrow"></div>
                <div class="arrow-border"></div>
                <ul>
                    <li><strong>Jabze Chat</strong> <a class="close-chat">x</a></li>
                </ul>
                <p id="tipmsg">
                    Jabze Chat enabled on this site. Please sign in (or register for an account)
                    to get connected with other users instantly.

                    <br><br>
                    <script type="text/javascript">
                        jQuery(function () {
                            var $ = jQuery;
                            //if ($.browser.mozilla) {
                            if ($.browser.msie && parseFloat($.browser.version) < 9) {
                                $("#tipmsg").html('<p style="color:red">Sorry your browser is not supported, please use Microsoft IE 9 or above, or a recent version of Firefox, Chrome or Safari browsers</p>');
                                return false;
                            }
                        });
                    </script>
                    <!--TODO: replace the next two lines with a red color dispay of:
                        "Sorry your browser is not supported, please use Microsoft IE 9 or above, or a recent version of
                         Firefox, Chrome or Safari browsers", if the browser is not supported.
                    -->
                    <a href="<?php echo wp_login_url(); ?>">Sign In</a> &nbsp; &nbsp; &nbsp; &nbsp;
                    <?php if(function_exists(wp_registration_url)){ ?><a href="<?php echo wp_registration_url(); ?>" >Register for an Account</a><?php }?>
                </p>
                <small style="font-size: smaller;">(To enable/disable this pop-up box permanently, please adjust the Jabze Chat plugin options)</small>
            </div>
            <div id="collective-xmpp-chat-data"></div>
            <div id="toggle-controlbox" class="open">
                <a href="javascript:;" class="chat toggle-online-users">
                    <strong class="conn-feedback">Jabze Chat</strong><strong id="jabze-show-help" style="color: green;">?</strong>
                </a>
            </div>

        </div>
        <script type="text/javascript">
            jQuery(function () {
                var $ = jQuery;
                var  notiBox=$('#jabze-noti-box');

                notiBox.delay(10*1000).fadeIn('slow');

                $('div#toggle-controlbox').click(function(){
                    notiBox.toggle();
                });
                $(".close-chat").click(function(){
                    notiBox.hide();
                });
            });
        </script>

    <?php

    endif;
}
add_action('wp_footer', 'jabze_widget');


if (is_admin())
    require_once dirname(__FILE__) . '/admin.php';
